routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

/**
 * All Admin Group Route 
*/
Route::group(['as' => 'admin.', 'prefix' => 'admin', 'namespace' => 'Admin'],  function() {
    // Admin Login and Logout
    Route::get('/login', 'Auth\LoginController@showLoginForm')->name('login'); 
    Route::post('/login', 'Auth\LoginController@login')->name('login.submit');
    Route::post('/logout', 'Auth\LoginController@adminLogout')->name('logout');
    // End 
    // Admin Dashboard
    Route::get('/', 'AdminController@index')->name('dashboard');
    // End 
    // Admin Profile
    Route::match(['get', 'patch'], '/profile','AdminController@profile')->name('profile');
    // End
    //Admin Setting 
    Route::get('setting/','SettingController@general')->name('setting');
    Route::get('setting/general/','SettingController@general')->name('setting.general');
    Route::get('setting/under-construction','SettingController@underConstruction')->name('setting.underconstruction');
    Route::post('setting/save/general','SettingController@save')->name('setting.general.save');
    Route::post('setting/save/underconstruction','SettingController@save')->name('setting.underconstruction.save');
    Route::get('setting/miscellaneous','SettingController@miscellaneous')->name('setting.miscellaneous');
    Route::post('setting/save/miscellaneous','SettingController@save')->name('setting.miscellaneous.save');
    //End

    // Media 
    Route::get('media/','MediaController@index')->name('media');
    Route::get('media/create','MediaController@create')->name('media.create');
    Route::post('media/store','MediaController@store')->name('media.store');
    Route::post('media/ckeditor','MediaController@ckditor_store')->name('media.ckeditor');
    Route::get('media/ckbrowse','MediaController@ckbrowse')->name('media.ckbrowse');
    Route::get('media/delete/{id}','MediaController@destroy')->name('media.delete');
    Route::post('media/delete-all','MediaController@deleteall')->name('media.delete.all');
    // end

    // Pages 
    Route::get('pages/','PageController@index')->name('pages');
    Route::get('page/create','PageController@create')->name('pages.create');
    Route::post('page/save','PageController@store')->name('pages.save');
    Route::get('page/edit/{id}','PageController@edit')->name('pages.edit');
    Route::post('page/update/{id}','PageController@update')->name('pages.update');
    Route::get('page/delete/{id}','PageController@destroy')->name('pages.delete');
    // End
    /**
     * Posts
     */
    Route::get('posts/','PostController@index')->name('posts');
    Route::get('post/create','PostController@create')->name('posts.create');
    Route::post('post/save','PostController@store')->name('posts.save');
    Route::get('post/edit/{id}','PostController@edit')->name('posts.edit');
    Route::post('post/update/{id}','PostController@update')->name('posts.update');
    Route::get('post/delete/{id}','PostController@destroy')->name('posts.delete');
    /**
     * End 
     */
    /**
     * Category
     */
    Route::get('categories/','CategoryController@index')->name('categories');
    Route::post('category/save','CategoryController@store')->name('categories.save');
    Route::get('category/edit/{id}','CategoryController@edit')->name('categories.edit');
    Route::post('category/update/{id}','CategoryController@update')->name('categories.update');
    Route::get('category/delete/{id}','CategoryController@destroy')->name('categories.delete');
    /**
     * End 
     */
    /**
     * Tags
     */
    Route::get('tags/','TagController@index')->name('tags');
    Route::post('tag/save','TagController@store')->name('tags.save');
    Route::get('tag/delete/{id}','TagController@destroy')->name('tags.delete');
    Route::get('tag/status/{id}','TagController@status')->name('tags.status');
    Route::post('tag/ajax','TagController@ajax')->name('tags.ajax');
    /**
     * End 
     */
    /**
     * Menus
     */
    Route::get('menus/','MenuController@index')->name('menus');
    Route::post('menu/save','MenuController@store')->name('menus.save');
    Route::get('menu/status/{id}','MenuController@status')->name('menus.status');
    Route::get('menu/edit/{id}','MenuController@edit')->name('menus.edit');
    Route::post('menu/update/{id}','MenuController@update')->name('menus.update');
    Route::get('menu/add-items/{id}','MenuController@addItem')->name('menus.additems');
    Route::post('menu/getdetails','MenuController@getMenuDetails')->name('menus.getdetail');
    Route::post('menu/items/save','MenuController@saveMenuItems')->name('menus.items.save');
    Route::get('menu/delete/{id}','MenuController@destroy')->name('menus.delete');
    /**
     * End 
     */

    /**
     * Admin User
     */
    Route::get('admin-users','AdminUsers@index')->name('adminusers');
    Route::get('admin-user/create','AdminUsers@create')->name('adminuser.create');
    Route::post('admin-user/save','AdminUsers@store')->name('adminuser.store');
    Route::get('admin-user/edit/{id}','AdminUsers@edit')->name('adminuser.edit');
    Route::post('admin-user/update/{id}','AdminUsers@update')->name('adminuser.update');
    Route::post('admin-user/special-permission/{id}','AdminUsers@specialPermission')->name('adminuser.special.permission');
    /**
     * End
     */
    /**
     * User
     */
    Route::get('users','UserController@index')->name('users');
    Route::get('user/create','UserController@create')->name('users.create');
    Route::post('user/store','UserController@store')->name('users.save');
    Route::get('user/edit/{id}','UserController@edit')->name('users.edit');
    Route::post('user/update/{id}','UserController@update')->name('users.update');
    /**
     * End
     */
    /**
     * Role
     */
    Route::get('roles','RoleController@index')->name('roles');
    Route::post('role/save','RoleController@store')->name('role.save');
    Route::get('role/edit/{id}','RoleController@edit')->name('role.edit');
    Route::post('role/update/{id}','RoleController@update')->name('role.update');
    Route::get('role/delete/{id}','RoleController@destroy')->name('role.delete');
    Route::post('role-add-to-permissions/{id}','RoleController@addRoleToPermissions')->name('roleToPermissions');
    /**
     * End 
     */
    /**
     * Permissions
     */
    Route::get('permissions','PermissionController@index')->name('permissions');
    Route::post('permission/save','PermissionController@store')->name('permission.save');
    Route::get('permission/edit/{id}','PermissionController@edit')->name('permission.edit');
    Route::post('permission/update/{id}','PermissionController@update')->name('permission.update');
    Route::get('permission/delete/{id}','PermissionController@destroy')->name('permission.delete');
    Route::post('permission-add-to-roles/{id}','PermissionController@addPermissionToRoles')->name('permissionToroles');
});
/**
 * End of Admin route
 */

// Route::get('/', function () {
//    dd();
// });
Route::get('/', 'PageController@index')->name('home-page');
// Route::get('/test', function () {
    
//     $a = Auth::guard('admin')->user();
//     $r = Userdata::get($a,'test');
//     dd($r);
// });
// Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Tag.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\CustomTraits\SeoMetaElements;
use App\CustomTraits\MediaTrait;
class Tag extends Model
{
    use SeoMetaElements,MediaTrait;
    protected $fillable = ['name','slug','status','content','image_id','mobile_image_id'];

    /**
     * Get The owning post
     */

    public function posts()
    {
        return $this->morphedByMany('App\Post', 'post_tag_relationships');
    }

    
}

app/Http/Controllers/Admin/TagController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Http\Requests\TagRequest;
use App\Tag;
use Slug;
use Str;
use Seo;
class TagController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth:admin');
        $this->middleware('permission:list.tag',['only'=>['index']]);
        $this->middleware('permission:store.tag',['only'=>'store']);
        $this->middleware('permission:store.tag.ajax',['only'=>'ajax']);
        $this->middleware('permission:change.tag.status',['only'=>'status']);
        $this->middleware('permission:delete.tag',['only'=>'destroy']);
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $tags = Tag::all();
        return view('admin.tags.list',compact('tags'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(TagRequest $request)
    {
        $inputs['name']=$request->name;
        $inputs['slug']=Str::slug($request->name);
        $inputs['status']=1;
        $result = Tag::create($inputs);
        if($result)
        {
            $result->meta_element()->create(['seo_title'=>$request->name]);
            return redirect()->route('admin.tags')
                        ->with('success','Tag created successfully.');
        }
    }

    /**
     * Create Tag through AJAX
     */
    public function ajax(Request $request)
    {
        if($request->ajax())
        {
            $tag = Tag::where(['name'=>$request->tag])->first();

            if($tag)
            {
                return response()->json(array('id'=>$tag->id,'name'=>$tag->name));
            }
            else
            {
                $inputs['name']=$request->tag;
                $inputs['slug']=Str::slug($request->tag);
                $inputs['status']=1;
                $result = Tag::create($inputs);
                if($result)
                {
                    $result->meta_element()->create(['seo_title'=>$request->tag]);
                    return response()->json(array('id'=>$result->id,'name'=>$result->name));
                }
            }
        }
    }
    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }
    /**
     * Change status of Tag
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function status($id)
    {
        $tag = Tag::find($id);
        if($tag->status == 1)
        {
           $res = $tag->update(['status'=>0]);
        }
        else
        {
            $res = $tag->update(['status'=>1]);
        }
        if($res)
        {
            return redirect()->route('admin.tags')
                            ->with('success','Tag status change successfully.');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $tag = Tag::find($id);
        $tag->posts()->detach();
        $tag->meta_element()->delete();
        $result = Tag::destroy($id);
        if($result )
        {
            return redirect()->route('admin.tags')
                            ->with('success','Tag deleted successfully.');
        }
    }
}

resources/views/admin/tags/list.blade.php
@extends('layouts.master')
@section('title') Tags @endsection
@section('content')
<header class="page-header">
    <h2>{{ __('Tags') }}</h2>

    <div class="right-wrapper pull-right">
        <ol class="breadcrumbs">
            <li>
                <a href="{{ url('admin') }}">
                    <i class="fa fa-home"></i>
                </a>
            </li>
            <li>
                <span>{{ __('Tags') }}</span>
            </li>
            
        </ol>

        <a class="sidebar-right-toggle" ></a>
    </div>
</header>

<div class="col-sm-12">
    <section class="panel">
        <header class="panel-heading">
            <div class="panel-actions">
                <a href="#" class="panel-action panel-action-toggle" data-panel-toggle=""></a>
                
            </div>
    
            <h2 class="panel-title">{{ __('Add Tag') }}</h2>
        </header>
        <div class="panel-body">
            {{  Form::open(array('route' => 'admin.tags.save','method' => 'POST','files'=> true))}}
            <div class="form-group @error('name') has-error @enderror">
                {{ Form::label('name', 'Name') }}
                
                {{ Form::text('name',null,array('id'=>'name','placeholder'=>'','class'=>'form-control')) }}
                @error('name')
                    <label id="name" class="error" >{{ $message }}</label>
                @enderror 
            </div>
            
            <div class="form-group">
                <input type="submit" class="mb-xs mt-xs mr-xs btn btn-primary" value="{{ __('Add') }}">
            </div>
            {{ Form::close() }}
        </div>
    </section>
</div>
<div class="col-sm-12">
    <section class="panel">
        <header class="panel-heading">
            <div class="panel-actions">
                <a href="#" class="panel-action panel-action-toggle" data-panel-toggle=""></a>
                
            </div>
    
            <h2 class="panel-title">{{ __('All Tags') }}</h2>
        </header>
        <div class="panel-body">
            <table class="table table-bordered table-striped mb-none" id="datatable-default">
                <thead>
                    <tr>
                        <th>Sl</th>
                        <th>Title</th>
                        <th>Slug</th>
                        <th>Status</th>
                        
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody>
                    @php ($i = 1)  
                    @foreach ($tags as $key =>$tag)
                    <tr>
                        <td>{{ $i++ }}</td>
                        <td>{{ $tag->name }}</td>
                        <td>{{ $tag->slug }}</td>
                        <td>
                            @if($tag->status == '1')
                                <a href="{{ route('admin.tags.status',$tag->id) }}" onclick="return confirm('Are you sure you want cahnge status ?');"><i class="fa fa-eye" aria-hidden="true"></i></a>
                            @else
                                <a href="{{ route('admin.tags.status',$tag->id) }}" onclick="return confirm('Are you sure you want cahnge status ?');"><i class="fa fa-eye-slash" aria-hidden="true"></i></a>
                            @endif

                        </td>
                        <td>
                            

                            <a href="{{ route('admin.tags.delete',$tag->id) }}" onclick="return confirm('Are you sure you want delete ?');"><i class="fa fa-trash-o" aria-hidden="true"></i></a>  

                            
                            
                        </td>
                    </tr>   
                    @endforeach
                    
                    
                </tbody>
            </table>
        </div>
    </section>
</div>
@endsection
@push('cssvender')
    <link rel="stylesheet" href="{{ asset('admin-design/assets/vendor/jquery-datatables-bs3/assets/css/datatables.css')}}" />
@endpush

@push('jsvender')
    <script src="{{ asset('admin-design/assets/vendor/jquery-datatables/media/js/jquery.dataTables.js')}}"></script>
	<script src="{{ asset('admin-design/assets/vendor/jquery-datatables/extras/TableTools/js/dataTables.tableTools.min.js')}}"></script>
    <script src="{{ asset('admin-design/assets/vendor/jquery-datatables-bs3/assets/js/datatables.js')}}"></script>
@endpush
@push('adminjs')
<script src="{{ asset('admin-design/assets/javascripts/tables/examples.datatables.default.js')}}"></script>
    @if ($message = Session::get('success'))
        <script>
            new PNotify({
                    title: 'Tag',
                    text: '{{ $message }}',
                    type: 'success'
                });
        </script>
    @endif
@endpush